<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * File for managing addresses
 * 
 */
require_once 'common.php';

HTML::printHead($css);

?>
<style type="text/css">
.box1{
     border: 1px solid gray;
     margin-bottom: 3px;
     padding: 2px;
     float: left;
     
}
.box1 a{
    display: block;
    padding: 2px;
}
</style>
<?php
//print_r($_SERVER);
HTML::printBody();
HTML::printHeadline($headline);

require_once 'include/bar_common.inc.php';


// Client id for address
set_client_id();

$tblc = new Tbl( $use['db_e']);


/***************************
 * Form before submit
 ***************************/
if (isset ($_REQUEST['id'])) 
{
    $address_id = $_REQUEST['id'];
}else{
    $address_id = $_SESSION['id'];
}

/**
 *  Client-ID
 */
$sql = "SELECT adr.id, id_tbl_client, client_no
    $rel_address_client
    WHERE adr.id = " . $_SESSION['id'];
    $address = $db->get_row_as_array($tbl_adr, "id = ". $address_id);
    #print_r($address);

// client id
$client_id = $address['id_tbl_client'];

// address id in case of old address
if (isset ($_SESSION['adr_old']) and $_SESSION['adr_old'] == 1) {
    $address_id_max = $address_id;

// address id in case of request of adr_id
}elseif (isset ($_REQUEST['adr_id']) and !empty($_REQUEST['adr_id'])) {
    $address_id_max = $address_id;

/**
 * Get actual address id from client id
 */
}else{
    /**
     * If id_tbl_client is empty, don't look for another address
     * because 0 is no ID and is used for all addresses without client-number.
     */
    if ( empty($address['id_tbl_client']) ) {
        $address_id_max = $address_id;

    /**
     * looking for the maximum id belongs to this client-id
     */
    }else{
        // Max of address id for this client id
        $condition = "id_tbl_client = " . $client_id;
        $address_id_max = $db->get_max($tbl_adr, 'id', $condition);
    }
}



if (!isset($_REQUEST['insert_data'])) {
    
/**
 * Menu start
 */
$menu = new Menu();
// back to adr
$arr = array ('tbl' => 'adr', 'new' => 1,);
$link_back = new Link();
$back_adr = $link_back->make_link('query.php', $la_back_to_address, $arr);
$menu->add_more_content($back_adr);
// back to ord
$back_ord = $link_back->make_link('order_edit.php', $la_back_to_order);
$menu->add_more_content($back_ord);
$menu->print_menu();
/*--------------------------------*/

?>
    <div class="box1">
    <h2>
            <?php print $la_action_for_client; ?>
    </h2>
    <br>
    <ul>

    <?php


    // New order
    $link = new Link();
    $arr2['adr_id'] = $address_id_max;
    $arr2['kun_id'] = $_SESSION['id'];
    $arr2['id'] = $address_id_max;
    $arr2['tbl'] = 'ord';
    $arr2['file'] = PROJECT_HTTP_ROOT. 'query.php';
    print $link->make_link('tbl_insert.php', $la_new_order, $arr2, '');
    #print '<br>';
    
    
    // New expense
    if (isset ($_REQUEST['id'])) {
        $arr2['kun_id'] = $_REQUEST['id'];
    }
    
    $link_menu = new Link_Menu();
    $arr2['tbl'] = 'exp';
    print $link_menu->insert_modul('expense', 'tbl_insert.php', $la_new_expense.'<br>', $arr2);
    
    
    // New complaint
    $complaint = PROJECT_DOCUMENT_ROOT . '/development/address_edit_complaint.inc.php';
    if (is_file($complaint)) {
        require_once $complaint;
    }
    
    
    // New price
    if (isset ($_REQUEST['id'])) {
        $arr2['adr_id'] = $_REQUEST['id'];
        $arr2['kun_id'] = $_REQUEST['id'];
    }
    $arr2['tbl'] = 'pri';
    $link->set_condition($use['mod_calc'] == 1);
    print $link->make_link('tbl_insert.php', $la_new_price,  $arr2, '');
    $link->set_condition(true);
    #print '<br>';

    
    // New letter
    if (isset ($_REQUEST['id'])) {
        $arr5['adr_id'] = $_REQUEST['id'];
        $arr5['kun_id'] = $_REQUEST['id'];
        $arr5['id'] = $_REQUEST['id'];
    }
    $arr5['tbl'] = 'let';
    print $link_menu->insert_modul('letter', 'tbl_insert.php', $la_new_letter.'<br>', $arr5);


    // Edit address
    $arr33['tbl'] = 'adr';
    $arr33['id'] = $address_id_max;
    $arr33['file'] =  'address_edit.php';
    print $link->make_link('tbl_edit.php', $la_address_data_edit, $arr33, '');
    #print '<br>';

    
    // Address history
    if ($address['id_tbl_client'] > 0) {
        $arr3['tbl'] = 'adr';
        $arr3['cop'] = 1; // cop = copy and paste
        if (isset ($_REQUEST['id'])) {
            $arr3['id'] = $_REQUEST['id'];
            $arr3['kun_id'] = $_REQUEST['id'];
        }
        $arr3['history'] = 1;
        $arr3['new'] = 1;
        $arr3['file'] =  'address_edit.php';
        $inscription = 'Alte Adressen ...';
        print $link->make_link($arr3['file'], $inscription, $arr3, $inscription);
        print '<br>';
    }   

    ?>
    </ul>
    </div>



   <div class="box1" style=" float: left; max-width: 400px;">
<?php
if (isset ($_SESSION['adr_old']) and $_SESSION['adr_old'] == 1) {
    $address_id = $_SESSION['mat_id'];
}elseif(isset ($_SESSION['adr_id'])) {
    $address_id = $_SESSION['adr_id'];
}


    // Display client-id
    if ($address['id_tbl_client'] > 0) {
        ?>
        <h2>Kunden-Nummer: <?php print $address['id_tbl_client']; ?>
        <span class="verysmall">( id_<?php print $address['id']; ?> ) 
        </span></h2>
       <?php

    // Link to insert client-id
    } else {
         // order_description
        $link = new Link();
        $arr2['adr_id'] = $address_id;
        if (isset ($_REQUEST['id'])) {
            $arr2['kun_id'] = $_REQUEST['id'];
        }
        $arr3['id'] = $address_id;
        $arr3['action'] = 'set_client_no';
        $inscription = $la_client_no_for_address;
        // insert client_no dont works, kunden-number will be only in tbl_adr
        $link_client_no = $link->make_link('address_edit.php', $inscription, $arr3, '');
        ?>
        <h2> 
            <?php print $la_client_nr_missing; ?> 
        </h2>
        <ul>
            <?php print $link_client_no; ?>
        </ul>
         <?php
    }


    /**
     * Current address
     */
    if (isset($_SESSION['adr_old']) and $_SESSION['adr_old'] == 1) {
        $address_curr_old = $la_address_old;
    }else{
        $address_curr_old = $la_address_current;
    }
    ?>
       <h2>
           <?php print $address_curr_old; ?>
       </h2>
    <?php

    $fields = array(
        'id','company', 'surname', 'forename', 'email', 'city', 'street',
        'date_insert', 'phone', 'fax', 'mobil', 'tax_id', 'id_tbl_country',
    );
    
    $qry = new Query();
    $qry->set_fields($fields);
    $fields = $qry->get_fields_with_alias();
    $sql = "
        SELECT $fields 
        FROM $tbl_adr
        WHERE id = " . $address_id_max ;
    
    $dump = new Db_Dump_Row($use['db_e']);
    $condition = "id = " . $address_id_max;
    $row = $db->get_row_as_array($tbl_adr, $condition, 'assoc');

    $skipped_fields = array(
        'old_id', 
        'id_tbl_worker', 
        'id_tbl_salutation',
        'country',
        'hide',
        'id_tbl_client',
        );
    $dump->skip_fields($skipped_fields);
    $dump->dump_row_as_table($row);
    

    ?>
    </div>
<br>
<div style="clear: both;">
<br>
<?php
// Google maps
        
// Start address
$condition = "id = " . $address_id_max . " ORDER BY id DESC LIMIT 1";
$ddd = new Dbc($use['db_e']);
$sadd = $ddd->get_row_as_array($tbl_adr, $condition);
$saddr = urlencode($sadd['street']);
$saddr .= ',+';
$saddr .= urlencode($sadd['postcode']);
$saddr .= '+';
$saddr .= urlencode($sadd['city']);
$saddr .= '&amp;';

// Destination address
$ddd = new Dbc($use['db_e']);
$dadd = $ddd->get_row_as_array($tbl_adm, "id=1");
$daddr = urlencode($dadd['street']);
$daddr .= ',+';
$daddr .= urlencode($dadd['postcode']);
$daddr .= '+';
$daddr .= urlencode($dadd['city']);
$daddr .= '&amp;';
?>
<div>
    <h1><a 
        href="<?php 
print 
 'http://maps.google.de/maps?'
#.'f=d&amp;'
#.'source=embeded&amp;'
.'saddr='.$saddr
.'daddr='.$daddr
#.'hl=de&amp;'
#.'geocode=FfLW_AIdWG-DACnlZ8JgnAm9RzFYKxuBp3e_bQ%3BFYrQ_AIdcL-EAClxv-WglQ69RzFY8NXOiZelmA&amp;'
#.'aq=0&amp;'
#.'sll=50.12453,8.61372&amp;'
#.'sspn=0.009836,0.019355&amp;'
#.'vpsrc=0&amp;'
#.'mra=ls&amp;'
#.'ie=UTF8&amp;'
#.'t=m&amp;'
#.'ll=50.128942,8.65551&amp;'
#.'spn=0.033014,0.051498&amp;'
#.'z=13&amp;'
#.'output=embed' ;
        ?>"
        style="color:#0000FF;text-align:left" target="blank">
        Routenplaner und Entfernung (neuer Tab)</a>
    </h1>
</div>
    <?php
if ($worker['maps_on'] == 1) {
?>
<iframe width="60%" height="60%" frameborder="0" scrolling="no" marginheight="0" marginwidth="0" 
        
src="<?php 
print 
 'http://maps.google.de/maps?'
.'saddr='.$saddr
.'daddr='.$daddr
.'output=embed' 
        ?>">

</iframe>
<br>
<?php
} // end map

?>
<p>&nbsp;</p>

    <?php

    /**
     * link: new product
     */
    if (isset($_REQUEST['id'])) {
        $arr2['adr_id'] = $_REQUEST['id'];
    }
    if (isset($_REQUEST['kund_id'])) {
        $arr2['id'] = $_REQUEST['kun_id'];
    }
    $arr2['kun_id'] = $address['id_tbl_client'];
    $arr2['src_tbl'] = 'pro';
    $arr2['target_tbl'] = 'cli_pro';
    $arr2['src_file'] = 'address_edit.php';
    $arr2['modus'] = 'eintrag';
    $arr2['page'] = 1;
    $arr2['new'] = 1;
    //print_r($arr2);


        $hide = show_or_hide_deleted_records('kuna.hide');
        
    /**
     * Show client article
     */
    if (!empty($address['id_tbl_client'])) {
        $menu = new Menu();
        $head1 = $html->html_x(1, $la_products_linked, 'span', 'font-weight:bold;');
        $inscription = 'Neuen Artikel zuordnen';
        $link_new = $link->make_link('article_select.php', $inscription, $arr2,
            'neuer Rabattartikel fr Kunde');
        $new_product = $html->html_x(1, $link_new, 'span');
        $menu->add_more_content($head1.$new_product);
        $qry = "SELECT id FROM $tbl_cli_pro WHERE hide = 1";
        $menu->show_hidden_records2($qry);
        $menu->print_menu();
        
        $sql = new Query();
        $arr_fields = array('art.id', 'description', 'sales_price');
        $sql->set_fields($arr_fields);
        $sql->set_order_field('art.id');
        $sql->set_table_or_relation($rel_client_product_product);
        $sql->set_query_where_part("kuna.id_tbl_client = " . $address['id_tbl_client']);
        $query = $sql->get_query();
        $tblc->set_fields($arr_fields);
        $tblc->set_query($query);
        $tblc->set_name_of_delete_field('kuna.hide');
        $tblc->set_link2($file, 'action=deallocate', 'Zuordnung aufheben');
        $tblc->show_table();
        print '<br>';
    }
    
    
    /**
     * List orders
     */
    ?>
    <div class="menux">
    <?php
    // Make Query
    $sql = new Query();
    $arr_fields = array(
        'auf.id', 
        'order_description', 
        'adr.id',
        'email',
        'auf.date_insert',
        'invoice_amount',
    );
    $sql->set_fields($arr_fields);
    $sql->set_table_or_relation($tbl_ord);
    $sql->set_table_or_relation($rel_order_address);
    $sql->set_order_field('auf.id');
    $sql->set_order_direction('DESC');
    
    // Query and subquery for orders
    if ($client_id > 0) {
        $condition = "id_tbl_address = ANY
            (SELECT id FROM $tbl_adr WHERE id_tbl_client = $client_id)";
        $sql->set_query_where_part($condition);
        
    // Query and subquery for orders
    }else{
        $sql->set_query_where_part("id_tbl_address = " . $address_id);
    }
    
    $query = $sql->get_query();
    
    
    $db_total = new Db_Total($use['db_e']);
    $summe_rech_betrag = $db_total->rows_total($query, $la_invoice_amount);
    print '<h2>'. $la_orders . ', ' . $la_sum . ': ' . $summe_rech_betrag . ' ' 
            . $adm['currency'] . '</h2>';
    ?>
    </div>
    <?php
    $tblc = new Tbl($use['db_e']);
    $tblc->set_fields($arr_fields);
    $tblc->set_name_of_delete_field('');
    $tblc->set_query($query);
    $tblc->set_limit(500);
    $target = 'order_edit.php';
    $tblc->set_link_target($target);
    $tblc->set_id_field($la_order_id);
    $tblc->set_field_as_link($la_order_id);
    $tblc->show_table();
    
    /**
     * List used delivery addresses for this client
     */
    ?>
    <br>
    <div class="menux">
    <?php
    print '<h2>'.$la_delivery_addresses_used.'</h2>';
    ?>
    </div>
    <?php
        // Make Query
    $sql = new Query();
    $arr_fields = array(
        'id_tbl_address_deliv', 
        'company', 
        'surname',
        'forename',
        'postcode',
        'city',
        'street',
    );
    $sql->set_fields($arr_fields);
    $sql->set_table_or_relation($rel_order_address);
    $sql->set_order_field('id_tbl_address_deliv');
    $sql->set_order_direction('DESC');
            $condition = "id_tbl_client = $client_id
        AND id_tbl_address_deliv != 0";
    $sql->set_query_where_part($condition);
    $query = $sql->get_query();
    $tblc->set_name_of_delete_field('');
    $tblc->set_fields($arr_fields);
    $tblc->set_query($query);
    $tblc->show_table();

    
    /**
     * show old addresses from this client
     */
    if (isset ($_REQUEST['history']) and $_REQUEST['history'] == 1) {

        print '<h1>' . $la_old_client_addresses . '</h1>';
        $qry = new Query();
        $qry->set_order_direction('DESC');

        /**
         * Make variable for field-array f.i. 'auf_fel_input'
         */
        $fields_for_query =  get_input_output_array('output');
        $qry->set_fields($fields_for_query);
        $qry->set_table_or_relation($tbl_adr);

        $where = "id_tbl_client = ".$client_id." and delivery_address_on < 1";
        $qry->set_query_where_part($where);

        $query = $qry->get_query();

        $tblc = new Tbl( $use['db_e']);
        $tblc->set_fields($fields_for_query);
        $tblc->set_field_as_link($la_id);
        $tblc->set_name_of_delete_field($la_hidden);
        $tblc->set_limit(1000);
        $tblc->set_id_field($la_id);
        $tblc->set_link_target('order_edit.php', $_SESSION['tbl'] == 'ord_ite');
        $arr7 = array('tbl' => $_SESSION['tbl'], 'file' => $_SERVER['PHP_SELF']);
        $tblc->set_link_queryarr($arr7);
        $tblc->set_link2('address_edit.php', 'adr_old=1', 'Diese Adresse verwenden');
        $tblc->set_link2_id_name_in_querystr('id');
        $tblc->set_query($query);
        $tblc->show_table();
    }
}
?>

</div>
<?php
HTML::printFoot();
?>