<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/**
* Description of tblnamec
*
* 
* Required: none
* 
* @since  2011-04
*/
class Tbl_Name 
{
    
    
/**
 * Turns the short form of table (adr) in the true name (tbl_#_adresse)
 *
 * @param type $tbl
 * @return mixed false or table name 
 */
function get_tbl_name($tbl = 'tbl') 
{

    if (!isset($_REQUEST[$tbl]) or empty ($_REQUEST[$tbl])) {
        if (isset($_SESSION[$tbl])) {
           $tbl_short = $_SESSION[$tbl];
        }else{
            return false;
        }

    }elseif(isset($_REQUEST[$tbl])) {
       $tbl_short = $_REQUEST[$tbl];
    }

    $tblprefix_and_tablename = 'tbl_' . $tbl_short;
    
    if (isset ($GLOBALS[$tblprefix_and_tablename]) and $GLOBALS[$tblprefix_and_tablename] == true) {
        $tblc = $GLOBALS[$tblprefix_and_tablename];
        return $tblc;
    }else{
        print 'Table don\'t exist: ' . $GLOBALS[$tblprefix_and_tablename];
        print '<br>' . $_SERVER['SCRIPT_NAME'];
        return false;
    }
}
    
    
} // end class