<?php
$path = '../../';
require_once $path . 'common.php';

/**
 * Page for changing worker settings 
 */
$db = new Dbc($use['db_e']);
$db->update_row($tbl);

HTML::printHead($css);
HTML::printBody();
HTML::printHeadline($headline);

include $path . 'include/bar_common.inc.php';
$file = 'modul/set/set.php';
$dok = 'operator';

include $path . 'include/bar_setting.inc.php';

/**
 * Date format in lists
 */
$arr = array(
        'Y-m-d' => 'Datenbankformat: 2011-03-15 (Jahr-Monat-Tag)' ,
        'd.m.Y' => 'Tag.Monat.Jahr',
    );
$arr = 'tbl=wor&change_data=1&id='.$worker['id'].'&time_format_list=Y-m-d';
$title = "Y-m-d -> 2011-08-03 -> Jahr-Monat-Tag";

$date_cont = $html->input(1, 'text', 'time_format_list', $worker['time_format_list'], 8)
            . ' '
            . $link->make_link('set.php', $la_restore_default, $arr, $title)
            // Explanation date system
            . $date_description;


$html = new Html_Element();
?>
<div id="tab">
<form method="post" action="<?php print PROJECT_HTTP_ROOT . 'tbl_edit.php';  ?>"
      style="display:inline">
<table>
    <?php
    $html->tr1();
        $html->set_th_td(1);
        $content = $adm['company_name'] . ' / ' . $worker['surname'];
        $html->tdh(true, $content, 'colspan="2" align="left"');
        $html->set_th_td(2);
    $html->tr2();
    $html->tr1();
        $t1 = $html->html_x(1, $la_rows_per_page, 'h2');
        $html->tdh(1, $t1);
        $t2 = $html->input(1, 'text', 'results_page', $worker['results_page']);
        $t2 .= '<br/>';
        $html->tdh(1, $t2);
    $html->tr2();
    $html->tr1();
        $t1 = $html->html_x(1, $la_characters_per_cell, 'h2');
        $html->tdh(1, $t1);
        $t2 = $html->input(1, 'text', 'column_width', $worker['column_width']);
        $t2 .= '<br/>';
        $html->tdh(1, $t2);
    $html->tr2();
    $html->tr1();
        $t1 = $html->html_x(1, $la_textarea_rows, 'h2');
        $html->tdh(1, $t1);
        $t2 = $html->input(1, 'text', 'textarea_rows', $worker['textarea_rows']);
        $t2 .= '<br/>';
        $html->tdh(1, $t2);
    $html->tr2();
    $html->tr1();
        $t1 = $html->html_x(1, $la_date_format .' '. $la_in_lists, 'h2');
        $html->tdh(1, $t1);
        $html->tdh(1, $date_cont);
    $html->tr2();
    $html->tr1();
        $t1 = $html->html_x(1, $la_maps_on, 'h2');
        $html->tdh(1, $t1);
        $t2 = $html->html_checkbox(1, 'maps_on', $worker['maps_on']);
        $html->tdh(1, $t2);
    $html->tr2();
    ?>
</table>
    <!--Settings-->
    <input type="hidden" name="tbl" value="wor">
    <input type="hidden" name="id" value="<?php print $worker['id']; ?>">
    <input type="hidden" name="file" value="<?php print $file; ?>">
    <div style="position: fixed; top: 100px; right: 10%; ">
            <input style="height: 5em;" type="submit" name="change_data" 
            value="<?php print $la_save_settings; ?>">
    </div>
</form>

<br/>
<p>
<?php
// Link free edit
$link_free_edit = new Link_Free_Edit();
print $link_free_edit->get_link();
?>
</p>
</div>
<?php
HTML::printFoot();
?>